package com.sillycycle.bagleyd.tetris;

// Learned a lot here
// http://www.edu4java.com/en/androidgame/androidgame1.html
import com.sillycycle.bagleyd.util.Colour;

import android.annotation.SuppressLint;
import android.content.Context;
//import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
//import android.graphics.Paint;
//import android.graphics.Rect;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

@SuppressLint("WrongCall")
public class GameView extends SurfaceView {
	GameLoopThread gameLoopThread;
	private long lastClick;
	//private Bitmap bmpGame;
	//private int count = 1;

	private int yDropSpeed = 10;
	private int yFallSpeed = 1;
	//private Paint fillPaint = new Paint();
	//private Rect fillRect = new Rect();
	PolyominoImage polyominoImage = new PolyominoImage();
	ThingView thingView = new ThingView();
	int currentSpeed = yFallSpeed;
	int flashCount = 2 * TetrisInterface.NUM_FLASHES + 1;
	boolean skip = true;
	int fill = -1;

    public GameView(Context context) {
        super(context);
        gameLoopThread = new GameLoopThread(this);

        getHolder().addCallback(new SurfaceHolder.Callback() {
		@Override
		public void surfaceDestroyed(SurfaceHolder holder) {
			boolean retry = true;
			gameLoopThread.setRunning(false);
			while (retry) {
				try {
					gameLoopThread.join();
					retry = false;
				} catch (InterruptedException e) {
					return;
				}
			}
		}

		@Override
		public void surfaceCreated(SurfaceHolder holder) {
			//create stuff
			gameLoopThread.setRunning(true);
			gameLoopThread.start();
		}

            @Override
            public void surfaceChanged(SurfaceHolder holder, int format,
			int width, int height) {
		//create stuff again for resize
		int columnWidth = getWidth() / TetrisInterface.DEFAULT_COLUMNS;
		int rowHeight = getHeight() / TetrisInterface.DEFAULT_ROWS;
		int size = alignUnits(columnWidth, rowHeight);

		polyominoImage.createBitmaps(true, false,
			size, new Colour(Colour.black));
		fill = -1;
		skip = true;
		currentSpeed = yFallSpeed;
		thingView.initFill(true, 4);
             }
          });
          //bmp = BitmapFactory.decodeResource(getResources(), R.drawable.tetris);
       }

       @Override
       protected void onDraw(Canvas canvas) {
	   //int width = bmp.getWidth();
	   int columnWidth = getWidth() / TetrisInterface.DEFAULT_COLUMNS;
	   int rowHeight = getHeight() / TetrisInterface.DEFAULT_ROWS;
	   int size = alignUnits(columnWidth, rowHeight);
	   int gameWidth = size * TetrisInterface.DEFAULT_COLUMNS;
	   int gameHeight = size * TetrisInterface.DEFAULT_ROWS;
	   int offsetX = (getWidth() - gameWidth) / 2;
	   int offsetY = (getHeight() - gameHeight) / 2;

           if (canvas == null)
		return;
           canvas.drawColor(Color.BLACK);
	   thingView.setBoxSize(size);
           thingView.setOffset(offsetX, offsetY);
           thingView.drawBorder(canvas);

           if (fill >= TetrisInterface.DEFAULT_ROWS)
		fill = 0;
           if (fill >= 0) {
		thingView.fillLines(canvas, polyominoImage, fill);
		thingView.drawField(canvas, polyominoImage);
		fill++;
			 return;
           }
	   if (flashCount <= 2 * TetrisInterface.NUM_FLASHES) {
		   if (flashCount == 2 * TetrisInterface.NUM_FLASHES) {
			   thingView.shrinkLines(canvas, polyominoImage);
			   thingView.drawField(canvas, polyominoImage);
			   flashCount++;
			   thingView.setNextThing();
			   skip = true;
			   if (thingView.overlapping()) {
				   fill = 0;
				   currentSpeed = yDropSpeed;
				   return;
			   }
			   return;
		   }
		   thingView.drawField(canvas, polyominoImage);
		   if (flashCount % 2 == 0)
			   thingView.invertLines(canvas, polyominoImage);
		   flashCount++;
		   return;
	   }
	   if (skip) {
		   skip = false;
	   } else {
		   if (!thingView.move(0, 1)) {
			   thingView.putUnit();
			   currentSpeed = yFallSpeed;
			   if (thingView.checkLines() > 0) {
				   flashCount = 0;
				   thingView.drawField(canvas, polyominoImage);
				   return;
			   }
			   thingView.setNextThing();
			   skip = true;
			   if (thingView.overlapping()) {
				   fill = 0;
				   currentSpeed = yDropSpeed;
				   return;
			   }
		   }
	   }
           thingView.drawField(canvas, polyominoImage);
           thingView.drawThing(canvas, polyominoImage);
       }

       @Override
       public boolean onTouchEvent(MotionEvent event) {
           if (System.currentTimeMillis() - lastClick > 300) {
               lastClick = System.currentTimeMillis();
               int boxSize = thingView.getBoxSize();
               int offsetX = thingView.getOffsetX();
               int offsetY = thingView.getOffsetY();
               float touchX = event.getX();
               float touchY = event.getY();
               int newX = ((int) (touchX - offsetX)) / boxSize;
               int newY = ((int) (touchY - offsetY)) / boxSize;

               if (newX < thingView.getX() + thingView.getFirstX()) {
			thingView.move(-1, 0);
			   return false;
               } else if (newX > thingView.getX() + thingView.getLastX()) {
			   thingView.move(1, 0);
			   return false;
               }
               /*if (thingView.isCollision(newX, newY))*/
               if (newY > thingView.getY() + thingView.getLastY()) {
			if (currentSpeed != yDropSpeed)
				currentSpeed = yDropSpeed;
               } else {
                       synchronized (getHolder()) {
				thingView.rotate();
                       }
                       performClick();
                       return true;
               }
           }
           return false;
       }

       @Override
       public boolean performClick() {
           super.performClick();
           // Handle the action for the custom click here
           return true;
       }

       static int alignUnits(int width , int height) {
	   if (width < height) {
		return (width >> 2) << 2;
	   }
	   return (height >> 2) << 2;
       }

       public int speed() {
	   return currentSpeed;
       }
}
